// Jean Luc Biellmann - contact@alsatux.com

"use strict";

function MdlFill () {
	this.row = {
		'date': '', // timestamp
		'counter': 0, // uint
		'price_per_litre': 0, // float
		'price': 0 // float
	};
	return this;
}

MdlFill.prototype = {
	upd_row: function (row) {
		try {
			row.date = _DateString.to_epoc(String(row.date).substr(0,10));
			row.counter = _Fmt.round(String(row.counter).substr(0,8),2);
			row.price_per_litre = _Fmt.round(String(row.price_per_litre).substr(0,8),2);
			row.price = _Fmt.round(String(row.price).substr(0,8),2);
			if (row.date!=null && row.counter>0. && row.price_per_litre>0. && row.price>0.) {
				this.row = row;
				return this;
			} else {
				throw tr('Missing or wrong datas !');
			}
		} catch (e) {
			throw 'MdlFill::upd_row(): ' + e;
		}
	},
	to_HTML: function () {
		var html = '';
			var vol=0.;
			var td = '';
			td += '<td>' + this.row.date.to_locale() + '</td>';
			td += '<td>' + String(this.row.counter).to_comma() + '</td>';
			if (this.row.price>0. && this.row.price_per_litre>0.) {
				vol = _Fmt.round(this.row.price/this.row.price_per_litre,2);
			} else {
				vol = '-';
			}
			td += '<td>' + String(vol).to_comma() + '</td>';
			td += '<td>' + String(this.row.price_per_litre).to_comma() + '</td>';
			td += '<td>' + String(this.row.price).to_comma() + '</td>';
			return '<tr>' + td + '</tr>';
	}
}
