// Jean Luc Biellmann - contact@alsatux.com

"use strict";

function MdlInsurance () {
	this.row = {
		'date': '', // timestamp
		'name': '', // insurer name
		'price': 0 // float
	};
	return this;
}

MdlInsurance.prototype = {
	upd_row: function (row) {
		try {
			row.date = _DateString.to_epoc(String(row.date).substr(0,10));
			row.name = String(row.name).substr(0,1000);
			row.price = _Fmt.round(String(row.price).substr(0,8),2);
			if (row.date!=null && row.name.length>0 && row.price>0.) {
				this.row = row;
				return this;
			} else {
				throw tr('Missing or wrong datas !');
			}
		} catch (e) {
			throw 'MdlInsurance::upd_row(): ' + e;
		}
	},
	to_HTML: function () {
		var td = '';
		td += '<td>' + this.row.date.to_locale() + '</td>';
		td += '<td>' + String(this.row.name).escape_html() + '</td>';
		td += '<td>' + String(this.row.price).to_comma() + '</td>';
		return '<tr>' + td + '</tr>';
	}
}
