// Jean Luc Biellmann - contact@alsatux.com

"use strict";

function MdlRepair () {
	this.row = {
		'date': '', // timestamp
		'garage': 0, // garage
		'desc': '', // description
		'price': 0. // float
	};
	return this;
}

MdlRepair.prototype = {
	upd_row: function (row) {
		try {
			row.date = _DateString.to_epoc(String(row.date).substr(0,10));
			row.garage = String(row.garage).substr(0,100);
			row.desc = String(row.desc).substr(0,1000);
			row.price = _Fmt.round(String(row.price).substr(0,8),2);
			if (row.date!=null && row.garage.length>0 && row.desc.length>0 && row.price>0.) {
				this.row = row;
				return this;
			} else {
				throw tr('Missing or wrong datas !');
			}
		} catch (e) {
			throw 'MdlRepair::upd_row(): ' + e;
		}
	},
	to_HTML: function () {
		var html = '';
		var td = '';
		td += '<td>' + this.row.date.to_locale() + '<br/>' + String(this.row.garage).escape_html() + '</td>';
		td += '<td class="left">' + String(this.row.desc).escape_html() + '</td>';
		td += '<td>' + String(this.row.price).to_comma() + '</td>';
		return '<tr>' + td + '</tr>';
	}
}
